Index: trunk/LMDZ.GENERIC/README
===================================================================
--- trunk/LMDZ.GENERIC/README	(revision 1304)
+++ trunk/LMDZ.GENERIC/README	(revision 1308)
@@ -1032,2 +1032,7 @@
 And some cosmetic cleanup in rain.F90, vdif_kc.F and turbdiff.F90
 
+== 10/07/2014 == EM
+Some cleanup to simplify dynamics/physics interactions by getting rid 
+of dimphys.h (i.e. the nlayermx parameter) and minimizing use of
+dimension.h in the physics.
+
Index: trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/aeropacity.F90	(revision 1308)
@@ -30,6 +30,6 @@
 !     pq                Aerosol mixing ratio
 !     reffrad(ngrid,nlayer,naerkind)         Aerosol effective radius
-!     QREFvis3d(ngrid,nlayermx,naerkind) \ 3d extinction coefficients
-!     QREFir3d(ngrid,nlayermx,naerkind)  / at reference wavelengths
+!     QREFvis3d(ngrid,nlayer,naerkind) \ 3d extinction coefficients
+!     QREFir3d(ngrid,nlayer,naerkind)  / at reference wavelengths
 !
 !     Output
@@ -40,9 +40,9 @@
 !=======================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "callkeys.h"
 #include "comcstfi.h"
-#include "comvert.h"
+!#include "comvert.h"
 
       INTEGER,INTENT(IN) :: ngrid  ! number of atmospheric columns
@@ -54,9 +54,9 @@
       REAL,INTENT(OUT) :: aerosol(ngrid,nlayer,naerkind) ! aerosol optical depth
       REAL,INTENT(IN) :: reffrad(ngrid,nlayer,naerkind) ! aerosol effective radius
-      REAL,INTENT(IN) :: QREFvis3d(ngrid,nlayermx,naerkind) ! extinction coefficient in the visible
-      REAL,INTENT(IN) :: QREFir3d(ngrid,nlayermx,naerkind)
+      REAL,INTENT(IN) :: QREFvis3d(ngrid,nlayer,naerkind) ! extinction coefficient in the visible
+      REAL,INTENT(IN) :: QREFir3d(ngrid,nlayer,naerkind)
       REAL,INTENT(OUT):: tau_col(ngrid) !column integrated visible optical depth
       ! BENJAMIN MODIFS
-      real,intent(in) :: cloudfrac(ngrid,nlayermx) ! cloud fraction
+      real,intent(in) :: cloudfrac(ngrid,nlayer) ! cloud fraction
       real,intent(out) :: totcloudfrac(ngrid) ! total cloud fraction
       logical,intent(in) :: clearsky
@@ -135,10 +135,10 @@
            iaer=iaero_co2
 !       1. Initialization
-            aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+            aerosol(1:ngrid,1:nlayer,iaer)=0.0
 !       2. Opacity calculation
             if (noaero) then ! aerosol set to zero
-             aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+             aerosol(1:ngrid,1:nlayer,iaer)=0.0
             elseif (aerofixco2.or.(i_co2ice.eq.0)) then !  CO2 ice cloud prescribed
-               aerosol(1:ngrid,1:nlayermx,iaer)=1.e-9
+               aerosol(1:ngrid,1:nlayer,iaer)=1.e-9
                !aerosol(1:ngrid,12,iaer)=4.0 ! single cloud layer option
             else
@@ -172,8 +172,8 @@
            iaer=iaero_h2o
 !       1. Initialization
-            aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+            aerosol(1:ngrid,1:nlayer,iaer)=0.0
 !       2. Opacity calculation
             if (aerofixh2o.or.(i_h2oice.eq.0).or.clearsky) then
-               aerosol(1:ngrid,1:nlayermx,iaer) =1.e-9
+               aerosol(1:ngrid,1:nlayer,iaer) =1.e-9
 
                ! put cloud at cloudlvl
@@ -226,5 +226,5 @@
 
                if(CLFvarying)then
-                  call totalcloudfrac(ngrid,nq,cloudfrac,totcloudfrac,pplev,pq,aerosol(1:ngrid,1:nlayermx,iaer))
+                  call totalcloudfrac(ngrid,nlayer,nq,cloudfrac,totcloudfrac,pplev,pq,aerosol(1,1,iaer))
                   do ig=1, ngrid
                      do l=1,nlayer-1 ! to stop the rad tran bug
@@ -253,5 +253,5 @@
           iaer=iaero_dust
 !         1. Initialization 
-          aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+          aerosol(1:ngrid,1:nlayer,iaer)=0.0
           
           topdust=30.0 ! km  (used to be 10.0 km) LK
@@ -264,5 +264,5 @@
 !             Typical mixing ratio profile
 
-                 zp=(preff/pplay(ig,l))**(70./topdust)
+                 zp=(pplev(ig,1)/pplay(ig,l))**(70./topdust)
                  expfactor=max(exp(0.007*(1.-max(zp,1.))),1.e-3)
 
@@ -277,6 +277,5 @@
 !          Rescaling each layer to reproduce the choosen (or assimilated)
 !          dust extinction opacity at visible reference wavelength, which
-!          is scaled to the "preff" reference surface pressure available in comvert.h
-!          and stored in startfi.nc
+!          is scaled to the surface pressure pplev(ig,1)
 
             taudusttmp(1:ngrid)=0.
@@ -291,5 +290,5 @@
                   aerosol(ig,l,iaer) = max(1E-20, &
                           dusttau &
-                       *  pplev(ig,1) / preff &
+                       *  pplev(ig,1) / pplev(ig,1) &
                        *  aerosol(ig,l,iaer) &
                        /  taudusttmp(ig))
@@ -307,5 +306,5 @@
 
 !       1. Initialization
-         aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+         aerosol(1:ngrid,1:nlayer,iaer)=0.0
 
 
@@ -317,5 +316,5 @@
 !              Typical mixing ratio profile
 
-               zp=(preff/pplay(ig,l))**(70./30) !emulating topdust
+               zp=(pplev(ig,1)/pplay(ig,l))**(70./30) !emulating topdust
                expfactor=max(exp(0.007*(1.-max(zp,1.))),1.e-3)
 
@@ -335,5 +334,5 @@
                aerosol(ig,l,iaer) = max(1E-20, &
                           1 &
-                       *  pplev(ig,1) / preff &
+                       *  pplev(ig,1) / pplev(ig,1) &
                        *  aerosol(ig,l,iaer) &
                        /  tauh2so4tmp(ig))
@@ -367,5 +366,5 @@
            iaer=iaero_back2lay
 !       1. Initialization
-            aerosol(1:ngrid,1:nlayermx,iaer)=0.0
+            aerosol(1:ngrid,1:nlayer,iaer)=0.0
 !       2. Opacity calculation
           DO ig=1,ngrid
Index: trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 1308)
@@ -32,6 +32,6 @@
 !     ==============================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "callkeys.h"
 
@@ -60,5 +60,5 @@
       INTEGER :: grid_i,grid_j
 !     Intermediate variable
-      REAL :: var_tmp,var3d_tmp(ngrid,nlayermx)
+      REAL :: var_tmp,var3d_tmp(ngrid,nlayer)
 !     Bilinear interpolation factors
       REAL :: kx,ky,k1,k2,k3,k4
@@ -161,24 +161,24 @@
       INTEGER :: ngrid,nlayer
 !     Aerosol effective radius used for radiative transfer (meter)
-      REAL :: reffrad(ngrid,nlayermx,naerkind)
+      REAL,INTENT(IN) :: reffrad(ngrid,nlayer,naerkind)
 !     Aerosol effective variance used for radiative transfer (n.u.)
-      REAL :: nueffrad(ngrid,nlayermx,naerkind)
+      REAL,INTENT(IN) :: nueffrad(ngrid,nlayer,naerkind)
 
 !     Outputs
 !     -------
 
-      REAL :: QVISsQREF3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-      REAL :: omegaVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-      REAL :: gVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-
-      REAL :: QIRsQREF3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-      REAL :: omegaIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-      REAL :: gIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-
-      REAL :: QREFvis3d(ngrid,nlayermx,naerkind)
-      REAL :: QREFir3d(ngrid,nlayermx,naerkind)
-
-      REAL :: omegaREFvis3d(ngrid,nlayermx,naerkind)
-      REAL :: omegaREFir3d(ngrid,nlayermx,naerkind)
+      REAL,INTENT(OUT) :: QVISsQREF3d(ngrid,nlayer,L_NSPECTV,naerkind)
+      REAL,INTENT(OUT) :: omegaVIS3d(ngrid,nlayer,L_NSPECTV,naerkind)
+      REAL,INTENT(OUT) :: gVIS3d(ngrid,nlayer,L_NSPECTV,naerkind)
+
+      REAL,INTENT(OUT) :: QIRsQREF3d(ngrid,nlayer,L_NSPECTI,naerkind)
+      REAL,INTENT(OUT) :: omegaIR3d(ngrid,nlayer,L_NSPECTI,naerkind)
+      REAL,INTENT(OUT) :: gIR3d(ngrid,nlayer,L_NSPECTI,naerkind)
+
+      REAL,INTENT(OUT) :: QREFvis3d(ngrid,nlayer,naerkind)
+      REAL,INTENT(OUT) :: QREFir3d(ngrid,nlayer,naerkind)
+
+      REAL :: omegaREFvis3d(ngrid,nlayer,naerkind)
+      REAL :: omegaREFir3d(ngrid,nlayer,naerkind)
 
       DO iaer = 1, naerkind ! Loop on aerosol kind
@@ -724,5 +724,5 @@
                         k2*omegrefIRgrid(grid_i+1,1,iaer)
           ENDIF                  ! --------------------------------
-        ENDDO !nlayermx
+        ENDDO !nlayer
       ENDDO !ngrid
 
Index: trunk/LMDZ.GENERIC/libf/phystd/calc_cpp_mugaz.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/calc_cpp_mugaz.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/calc_cpp_mugaz.F90	(revision 1308)
@@ -20,6 +20,6 @@
       implicit none
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
Index: trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/calcenergy_kcm.F90	(revision 1308)
@@ -1,3 +1,3 @@
-subroutine calcenergy_kcm(Tsurf,T,Play,Plev,Qsurf,Q,muvar,Eatmtot)
+subroutine calcenergy_kcm(nlayer,Tsurf,T,Play,Plev,Qsurf,Q,muvar,Eatmtot)
 
 
@@ -11,6 +11,6 @@
 !     ----------------------------------------------------------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 !#include "callkeys.h"
@@ -19,8 +19,9 @@
 
   ! inputs
-  real Tsurf,T(1:nlayermx)
-  real Play(1:nlayermx),Plev(1:nlayermx+1)
-  real Qsurf,Q(1:nlayermx)
-  real muvar(1,nlayermx+1)
+  integer,intent(in) :: nlayer
+  real Tsurf,T(1:nlayer)
+  real Play(1:nlayer),Plev(1:nlayer+1)
+  real Qsurf,Q(1:nlayer)
+  real muvar(1,nlayer+1)
 
   ! internal
@@ -29,5 +30,5 @@
   real s_c,rho_v,L
   double precision p_v, s_v, nul
-  real VMR(1:nlayermx)
+  real VMR(1:nlayer)
 
   ! output
@@ -41,5 +42,5 @@
 
 
-  do il=1,nlayermx
+  do il=1,nlayer
      VMR(il)=Q(il)*(muvar(1,il+1)/mH2O)
   end do
@@ -47,5 +48,5 @@
 
   Eatmtot = 0.0
-  do il=1,nlayermx
+  do il=1,nlayer
 
 
Index: trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/callcorrk.F90	(revision 1308)
@@ -35,5 +35,5 @@
 !==================================================================
 
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -42,5 +42,5 @@
 !     Declaration of the arguments (INPUT - OUTPUT) on the LMD GCM grid
 !     Layer #1 is the layer near the ground. 
-!     Layer #nlayermx is the layer at the top.
+!     Layer #nlayer is the layer at the top.
 
       INTEGER,INTENT(IN) :: ngrid ! number of atmospheric columns
@@ -52,14 +52,14 @@
       REAL,INTENT(IN) :: emis(ngrid)     ! LW emissivity
       real,intent(in) :: mu0(ngrid) ! cosine of sun incident angle
-      REAL,INTENT(IN) :: pplev(ngrid,nlayermx+1)  ! inter-layer pressure (Pa)
-      REAL,INTENT(IN) :: pplay(ngrid,nlayermx)    ! mid-layer pressure (Pa)
-      REAL,INTENT(IN) :: pt(ngrid,nlayermx)  ! air temperature (K)
+      REAL,INTENT(IN) :: pplev(ngrid,nlayer+1)  ! inter-layer pressure (Pa)
+      REAL,INTENT(IN) :: pplay(ngrid,nlayer)    ! mid-layer pressure (Pa)
+      REAL,INTENT(IN) :: pt(ngrid,nlayer)  ! air temperature (K)
       REAL,INTENT(IN) :: tsurf(ngrid)        ! surface temperature (K)
       REAL,INTENT(IN) :: fract(ngrid)        ! fraction of day
       REAL,INTENT(IN) :: dist_star           ! distance star-planet (AU)
-      REAL,INTENT(OUT) :: aerosol(ngrid,nlayermx,naerkind) ! aerosol tau (kg/kg)
-      real,intent(in) :: muvar(ngrid,nlayermx+1)
-      REAL,INTENT(OUT) :: dtlw(ngrid,nlayermx) ! heating rate (K/s) due to LW
-      REAL,INTENT(OUT) :: dtsw(ngrid,nlayermx) ! heating rate (K/s) due to SW
+      REAL,INTENT(OUT) :: aerosol(ngrid,nlayer,naerkind) ! aerosol tau (kg/kg)
+      real,intent(in) :: muvar(ngrid,nlayer+1)
+      REAL,INTENT(OUT) :: dtlw(ngrid,nlayer) ! heating rate (K/s) due to LW
+      REAL,INTENT(OUT) :: dtsw(ngrid,nlayer) ! heating rate (K/s) due to SW
       REAL,INTENT(OUT) :: fluxsurf_lw(ngrid)   ! incident LW flux to surf (W/m2)
       REAL,INTENT(OUT) :: fluxsurf_sw(ngrid)   ! incident SW flux to surf (W/m2)
@@ -71,5 +71,5 @@
       REAL,INTENT(OUT) :: tau_col(ngrid) ! diagnostic from aeropacity
 !     for H2O cloud fraction in aeropacity
-      real,intent(in) :: cloudfrac(ngrid,nlayermx)
+      real,intent(in) :: cloudfrac(ngrid,nlayer)
       real,intent(out) :: totcloudfrac(ngrid)
       logical,intent(in) :: clearsky
@@ -79,14 +79,14 @@
 !     Globally varying aerosol optical properties on GCM grid
 !     Not needed everywhere so not in radcommon_h
-      REAL :: QVISsQREF3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-      REAL :: omegaVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-      REAL :: gVIS3d(ngrid,nlayermx,L_NSPECTV,naerkind)
-
-      REAL :: QIRsQREF3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-      REAL :: omegaIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-      REAL :: gIR3d(ngrid,nlayermx,L_NSPECTI,naerkind)
-
-!      REAL :: omegaREFvis3d(ngrid,nlayermx,naerkind)
-!      REAL :: omegaREFir3d(ngrid,nlayermx,naerkind) ! not sure of the point of these...
+      REAL :: QVISsQREF3d(ngrid,nlayer,L_NSPECTV,naerkind)
+      REAL :: omegaVIS3d(ngrid,nlayer,L_NSPECTV,naerkind)
+      REAL :: gVIS3d(ngrid,nlayer,L_NSPECTV,naerkind)
+
+      REAL :: QIRsQREF3d(ngrid,nlayer,L_NSPECTI,naerkind)
+      REAL :: omegaIR3d(ngrid,nlayer,L_NSPECTI,naerkind)
+      REAL :: gIR3d(ngrid,nlayer,L_NSPECTI,naerkind)
+
+!      REAL :: omegaREFvis3d(ngrid,nlayer,naerkind)
+!      REAL :: omegaREFir3d(ngrid,nlayer,naerkind) ! not sure of the point of these...
 
       REAL,ALLOCATABLE,SAVE :: reffrad(:,:,:) ! aerosol effective radius (m)
@@ -141,6 +141,6 @@
       real*8,save ::  GIAER(L_LEVELS+1,L_NSPECTI,naerkind)
 
-      !REAL :: QREFvis3d(ngrid,nlayermx,naerkind)
-      !REAL :: QREFir3d(ngrid,nlayermx,naerkind)
+      !REAL :: QREFvis3d(ngrid,nlayer,naerkind)
+      !REAL :: QREFir3d(ngrid,nlayer,naerkind)
       !save QREFvis3d, QREFir3d 
       real, dimension(:,:,:), save, allocatable :: QREFvis3d
@@ -177,5 +177,5 @@
 
 !     included by RW for runaway greenhouse 1D study
-      real vtmp(nlayermx)
+      real vtmp(nlayer)
       REAL*8 muvarrad(L_LEVELS)
 
@@ -195,6 +195,6 @@
          !!! ALLOCATED instances are necessary because of CLFvarying
          !!! strategy to call callcorrk twice in physiq...
-         IF(.not.ALLOCATED(QREFvis3d)) ALLOCATE(QREFvis3d(ngrid,nlayermx,naerkind))
-         IF(.not.ALLOCATED(QREFir3d)) ALLOCATE(QREFir3d(ngrid,nlayermx,naerkind))
+         IF(.not.ALLOCATED(QREFvis3d)) ALLOCATE(QREFvis3d(ngrid,nlayer,naerkind))
+         IF(.not.ALLOCATED(QREFir3d)) ALLOCATE(QREFir3d(ngrid,nlayer,naerkind))
          ! Effective radius and variance of the aerosols
          IF(.not.ALLOCATED(reffrad)) allocate(reffrad(ngrid,nlayer,naerkind))
@@ -207,5 +207,5 @@
             call abort
          endif
-         call su_aer_radii(ngrid,reffrad,nueffrad)
+         call su_aer_radii(ngrid,nlayer,reffrad,nueffrad)
 	 
 	 
@@ -266,20 +266,20 @@
 
          if ((iaer.eq.iaero_co2).and.tracer.and.(igcm_co2_ice.gt.0)) then ! treat condensed co2 particles.
-	    call co2_reffrad(ngrid,nq,pq,reffrad(1,1,iaero_co2))
-            print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
-            print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
+	    call co2_reffrad(ngrid,nlayer,nq,pq,reffrad(1,1,iaero_co2))
+            print*,'Max. CO2 ice particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
+            print*,'Min. CO2 ice particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
 	 end if
          if ((iaer.eq.iaero_h2o).and.water) then ! treat condensed water particles. to be generalized for other aerosols
-	    call h2o_reffrad(ngrid,pq(1,1,igcm_h2o_ice),pt, &
+	    call h2o_reffrad(ngrid,nlayer,pq(1,1,igcm_h2o_ice),pt, &
                              reffrad(1,1,iaero_h2o),nueffrad(1,1,iaero_h2o))
-            print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
-            print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngrid,1:nlayermx,iaer))/1.e-6,' um'
+            print*,'Max. H2O cloud particle size = ',maxval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
+            print*,'Min. H2O cloud particle size = ',minval(reffrad(1:ngrid,1:nlayer,iaer))/1.e-6,' um'
          endif
          if(iaer.eq.iaero_dust)then
-	    call dust_reffrad(ngrid,reffrad(1,1,iaero_dust))
+	    call dust_reffrad(ngrid,nlayer,reffrad(1,1,iaero_dust))
             print*,'Dust particle size = ',reffrad(1,1,iaer)/1.e-6,' um'
          endif
          if(iaer.eq.iaero_h2so4)then
-	    call h2so4_reffrad(ngrid,reffrad(1,1,iaero_h2so4))
+	    call h2so4_reffrad(ngrid,nlayer,reffrad(1,1,iaero_h2so4))
             print*,'H2SO4 particle size =',reffrad(1,1,iaer)/1.e-6,' um'
          endif
@@ -318,23 +318,23 @@
             do iaer=1,naerkind
                DO nw=1,L_NSPECTV 
-                  do l=1,nlayermx
-
-                     temp1=QVISsQREF3d(ig,nlayermx+1-l,nw,iaer)         &
-                         *QREFvis3d(ig,nlayermx+1-l,iaer)
-
-                     temp2=QVISsQREF3d(ig,max(nlayermx-l,1),nw,iaer)    &
-                         *QREFvis3d(ig,max(nlayermx-l,1),iaer)
+                  do l=1,nlayer
+
+                     temp1=QVISsQREF3d(ig,nlayer+1-l,nw,iaer)         &
+                         *QREFvis3d(ig,nlayer+1-l,iaer)
+
+                     temp2=QVISsQREF3d(ig,max(nlayer-l,1),nw,iaer)    &
+                         *QREFvis3d(ig,max(nlayer-l,1),iaer)
 
                      qxvaer(2*l,nw,iaer)  = temp1
                      qxvaer(2*l+1,nw,iaer)=(temp1+temp2)/2
 
-                     temp1=temp1*omegavis3d(ig,nlayermx+1-l,nw,iaer)
-                     temp2=temp2*omegavis3d(ig,max(nlayermx-l,1),nw,iaer)
+                     temp1=temp1*omegavis3d(ig,nlayer+1-l,nw,iaer)
+                     temp2=temp2*omegavis3d(ig,max(nlayer-l,1),nw,iaer)
 
                      qsvaer(2*l,nw,iaer)  = temp1
                      qsvaer(2*l+1,nw,iaer)=(temp1+temp2)/2
 
-                     temp1=gvis3d(ig,nlayermx+1-l,nw,iaer)
-                     temp2=gvis3d(ig,max(nlayermx-l,1),nw,iaer)
+                     temp1=gvis3d(ig,nlayer+1-l,nw,iaer)
+                     temp2=gvis3d(ig,max(nlayer-l,1),nw,iaer)
 
                      gvaer(2*l,nw,iaer)  = temp1
@@ -344,11 +344,11 @@
 
                   qxvaer(1,nw,iaer)=qxvaer(2,nw,iaer)
-                  qxvaer(2*nlayermx+1,nw,iaer)=0.
+                  qxvaer(2*nlayer+1,nw,iaer)=0.
 
                   qsvaer(1,nw,iaer)=qsvaer(2,nw,iaer)
-                  qsvaer(2*nlayermx+1,nw,iaer)=0.
+                  qsvaer(2*nlayer+1,nw,iaer)=0.
 
                   gvaer(1,nw,iaer)=gvaer(2,nw,iaer)
-                  gvaer(2*nlayermx+1,nw,iaer)=0.
+                  gvaer(2*nlayer+1,nw,iaer)=0.
 
                end do
@@ -356,23 +356,23 @@
 !     longwave
                DO nw=1,L_NSPECTI 
-                  do l=1,nlayermx
-
-                     temp1=QIRsQREF3d(ig,nlayermx+1-l,nw,iaer)         &
-                          *QREFir3d(ig,nlayermx+1-l,iaer)
-
-                     temp2=QIRsQREF3d(ig,max(nlayermx-l,1),nw,iaer)    &
-                          *QREFir3d(ig,max(nlayermx-l,1),iaer)
+                  do l=1,nlayer
+
+                     temp1=QIRsQREF3d(ig,nlayer+1-l,nw,iaer)         &
+                          *QREFir3d(ig,nlayer+1-l,iaer)
+
+                     temp2=QIRsQREF3d(ig,max(nlayer-l,1),nw,iaer)    &
+                          *QREFir3d(ig,max(nlayer-l,1),iaer)
 
                      qxiaer(2*l,nw,iaer)  = temp1
                      qxiaer(2*l+1,nw,iaer)=(temp1+temp2)/2
 
-                     temp1=temp1*omegair3d(ig,nlayermx+1-l,nw,iaer)
-                     temp2=temp2*omegair3d(ig,max(nlayermx-l,1),nw,iaer)
+                     temp1=temp1*omegair3d(ig,nlayer+1-l,nw,iaer)
+                     temp2=temp2*omegair3d(ig,max(nlayer-l,1),nw,iaer)
 
                      qsiaer(2*l,nw,iaer)  = temp1
                      qsiaer(2*l+1,nw,iaer)=(temp1+temp2)/2
 
-                     temp1=gir3d(ig,nlayermx+1-l,nw,iaer)
-                     temp2=gir3d(ig,max(nlayermx-l,1),nw,iaer)
+                     temp1=gir3d(ig,nlayer+1-l,nw,iaer)
+                     temp2=gir3d(ig,max(nlayer-l,1),nw,iaer)
 
                      giaer(2*l,nw,iaer)  = temp1
@@ -382,11 +382,11 @@
 
                   qxiaer(1,nw,iaer)=qxiaer(2,nw,iaer)
-                  qxiaer(2*nlayermx+1,nw,iaer)=0.
+                  qxiaer(2*nlayer+1,nw,iaer)=0.
 
                   qsiaer(1,nw,iaer)=qsiaer(2,nw,iaer)
-                  qsiaer(2*nlayermx+1,nw,iaer)=0.
+                  qsiaer(2*nlayer+1,nw,iaer)=0.
 
                   giaer(1,nw,iaer)=giaer(2,nw,iaer)
-                  giaer(2*nlayermx+1,nw,iaer)=0.
+                  giaer(2*nlayer+1,nw,iaer)=0.
 
                end do
@@ -481,5 +481,5 @@
       elseif(varfixed)then
 
-         do l=1,nlayermx        ! here we will assign fixed water vapour profiles globally
+         do l=1,nlayer        ! here we will assign fixed water vapour profiles globally
             RH = satval * ((pplay(ig,l)/pplev(ig,1) - 0.02) / 0.98)
             if(RH.lt.0.0) RH=0.0
@@ -507,5 +507,5 @@
 !         call watersat(Ttemp,ptemp,qsat)
 
-         qvar(2*nlayermx+1)= RH * qsat ! ~realistic profile (e.g. 80% saturation at ground)
+         qvar(2*nlayer+1)= RH * qsat ! ~realistic profile (e.g. 80% saturation at ground)
  
       else
@@ -541,5 +541,5 @@
       
             muvarrad(1) = muvarrad(2)
-            muvarrad(2*nlayermx+1)=muvar(ig,1)
+            muvarrad(2*nlayer+1)=muvar(ig,1)
 
             print*,'Recalculating qvar with VARIABLE epsi for kastprof'
@@ -579,5 +579,5 @@
       
          muvarrad(1) = muvarrad(2)
-         muvarrad(2*nlayermx+1)=muvar(ig,1)         
+         muvarrad(2*nlayer+1)=muvar(ig,1)         
       endif
       
@@ -607,5 +607,5 @@
 
       tlevrad(1) = tlevrad(2)
-      tlevrad(2*nlayermx+1)=tsurf(ig)
+      tlevrad(2*nlayer+1)=tsurf(ig)
       
       tmid(1) = tlevrad(2)
Index: trunk/LMDZ.GENERIC/libf/phystd/callsedim.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/callsedim.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/callsedim.F	(revision 1308)
@@ -28,6 +28,6 @@
 c   -------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -65,5 +65,5 @@
       real epaisseur (ngrid,nlay) ! Layer thickness (m)
       real wq(ngrid,nlay+1) ! displaced tracer mass (kg.m-2)
-c      real dens(ngrid,nlayermx) ! Mean density of the ice part. accounting for dust core
+c      real dens(ngrid,nlay) ! Mean density of the ice part. accounting for dust core
 
 
@@ -125,5 +125,5 @@
           if (water.and.(iq.eq.igcm_h2o_ice)) then
             ! compute radii for h2o_ice 
-             call h2o_reffrad(ngrid,zqi(1,1,igcm_h2o_ice),zt,
+             call h2o_reffrad(ngrid,nlay,zqi(1,1,igcm_h2o_ice),zt,
      &                reffrad(1,1,iaero_h2o),nueffrad(1,1,iaero_h2o))
             ! call sedimentation for h2o_ice
Index: trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90	(revision 1308)
@@ -32,5 +32,5 @@
 !     ptsrf(ngrid)          Surface temperature
 !     
-!     pdt(ngrid,nlayermx)   Time derivative before condensation/sublimation of pt
+!     pdt(ngrid,nlayer)   Time derivative before condensation/sublimation of pt
 !     pdtsrf(ngrid)         Time derivative before condensation/sublimation of ptsrf
 !     pqsurf(ngrid,nq)      Sedimentation flux at the surface (kg.m-2.s-1)
@@ -38,7 +38,7 @@
 !     Outputs
 !     -------
-!     pdpsrf(ngrid)         \  Contribution of condensation/sublimation
-!     pdtc(ngrid,nlayermx)  /  to the time derivatives of Ps, pt, and ptsrf
-!     pdtsrfc(ngrid)       /
+!     pdpsrf(ngrid)       \  Contribution of condensation/sublimation
+!     pdtc(ngrid,nlayer)  /  to the time derivatives of Ps, pt, and ptsrf
+!     pdtsrfc(ngrid)     /
 !     
 !     Both
@@ -56,8 +56,8 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
-#include "comvert.h"
+!#include "comvert.h"
 #include "callkeys.h"
 
@@ -99,30 +99,30 @@
 
       REAL reffrad(ngrid,nlayer) ! radius (m) of the co2 ice particles
-      REAL*8 zt(ngrid,nlayermx)
-      REAL zq(ngrid,nlayermx,nq)
+      REAL*8 zt(ngrid,nlayer)
+      REAL zq(ngrid,nlayer,nq)
       REAL zcpi
-      REAL ztcond (ngrid,nlayermx)
-      REAL ztnuc (ngrid,nlayermx)
+      REAL ztcond (ngrid,nlayer)
+      REAL ztnuc (ngrid,nlayer)
       REAL ztcondsol(ngrid) 
       REAL zdiceco2(ngrid)
-      REAL zcondicea(ngrid,nlayermx), zcondices(ngrid)
+      REAL zcondicea(ngrid,nlayer), zcondices(ngrid)
       REAL zfallice(ngrid), Mfallice(ngrid) 
-      REAL zmflux(nlayermx+1)
-      REAL zu(nlayermx),zv(nlayermx)
+      REAL zmflux(nlayer+1)
+      REAL zu(nlayer),zv(nlayer)
       REAL ztsrf(ngrid)
-      REAL ztc(nlayermx), ztm(nlayermx+1) 
-      REAL zum(nlayermx+1) , zvm(nlayermx+1)
+      REAL ztc(nlayer), ztm(nlayer+1) 
+      REAL zum(nlayer+1) , zvm(nlayer+1)
       LOGICAL condsub(ngrid)
       REAL subptimestep
       Integer Ntime
-      real masse (ngrid,nlayermx), w(ngrid,nlayermx,nq)
-      real wq(ngrid,nlayermx+1)
+      real masse (ngrid,nlayer), w(ngrid,nlayer,nq)
+      real wq(ngrid,nlayer+1)
       real vstokes,reff
 
 !     Special diagnostic variables
-      real tconda1(ngrid,nlayermx)
-      real tconda2(ngrid,nlayermx)
-      real zdtsig (ngrid,nlayermx)
-      real zdt (ngrid,nlayermx)
+      real tconda1(ngrid,nlayer)
+      real tconda2(ngrid,nlayer)
+      real zdtsig (ngrid,nlayer)
+      real zdt (ngrid,nlayer)
 
 !-----------------------------------------------------------------------
@@ -205,5 +205,5 @@
 !     zcondices(ngrid)     condensation rate on the ground  (kg/m2/s)
 !     zfallice(ngrid)      flux of ice falling on surface   (kg/m2/s)
-!     pdtc(ngrid,nlayermx) dT/dt due to phase changes       (K/s)
+!     pdtc(ngrid,nlayer) dT/dt due to phase changes       (K/s)
      
 
@@ -301,5 +301,5 @@
             
 !     sedimentation computed from radius computed from q in module radii_mod
-	 call co2_reffrad(ngrid,nq,zq,reffrad)
+	 call co2_reffrad(ngrid,nlayer,nq,zq,reffrad)
 	 
          do  ilay=1,nlayer
@@ -321,5 +321,5 @@
 !     Computing q after sedimentation
 
-         call vlz_fi(ngrid,zq(1,1,i_co2ice),2.,masse,w(1,1,i_co2ice),wq)
+         call vlz_fi(ngrid,nlayer,zq(1,1,i_co2ice),2.,masse,w(1,1,i_co2ice),wq)
 
 
Index: trunk/LMDZ.GENERIC/libf/phystd/convadj.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/convadj.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/convadj.F	(revision 1308)
@@ -29,6 +29,6 @@
 !     ------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -57,9 +57,9 @@
       INTEGER jcnt, jadrs(ngrid)
 
-      REAL sig(nlayermx+1),sdsig(nlayermx),dsig(nlayermx)
-      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
-      REAL zh(ngrid,nlayermx)
-      REAL zu2(ngrid,nlayermx),zv2(ngrid,nlayermx)
-      REAL zh2(ngrid,nlayermx), zhc(ngrid,nlayermx)
+      REAL sig(nlay+1),sdsig(nlay),dsig(nlay)
+      REAL zu(ngrid,nlay),zv(ngrid,nlay)
+      REAL zh(ngrid,nlay)
+      REAL zu2(ngrid,nlay),zv2(ngrid,nlay)
+      REAL zh2(ngrid,nlay), zhc(ngrid,nlay)
       REAL zhm,zsm,zdsm,zum,zvm,zalpha,zhmc
 
@@ -67,5 +67,5 @@
       INTEGER iq,ico2
       save ico2
-      REAL zq(ngrid,nlayermx,nq), zq2(ngrid,nlayermx,nq)
+      REAL zq(ngrid,nlay,nq), zq2(ngrid,nlay,nq)
       REAL zqm(nq),zqco2m
       real m_co2, m_noco2, A , B
Index: trunk/LMDZ.GENERIC/libf/phystd/evap.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/evap.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/evap.F	(revision 1308)
@@ -1,3 +1,3 @@
-      subroutine evap(ngrid,nq,dtime,pt, pq, pdq, pdt,  
+      subroutine evap(ngrid,nlayer,nq,dtime,pt, pq, pdq, pdt,  
      $     dqevap,dtevap, qevap, tevap) 
         
@@ -7,6 +7,6 @@
       implicit none
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 
@@ -24,18 +24,18 @@
 !==================================================================
 
-      INTEGER ngrid,nq
+      INTEGER ngrid,nlayer,nq
 
 ! Arguments:
-      REAL pt(ngrid,nlayermx) 
-      REAL pq(ngrid,nlayermx,nq) 
-      REAL pdt(ngrid,nlayermx) 
-      REAL pdq(ngrid,nlayermx,nq) 
-      REAL dqevap(ngrid,nlayermx)
-      REAL dtevap(ngrid,nlayermx)
-      REAL qevap(ngrid,nlayermx,nq)
+      REAL pt(ngrid,nlayer) 
+      REAL pq(ngrid,nlayer,nq) 
+      REAL pdt(ngrid,nlayer) 
+      REAL pdq(ngrid,nlayer,nq) 
+      REAL dqevap(ngrid,nlayer)
+      REAL dtevap(ngrid,nlayer)
+      REAL qevap(ngrid,nlayer,nq)
       REAL dtime
  
 ! Local:
-      REAL tevap(ngrid,nlayermx) 
+      REAL tevap(ngrid,nlayer) 
       REAL zlvdcp
       REAL zlsdcp
@@ -47,5 +47,5 @@
 !
 
-      DO l=1,nlayermx
+      DO l=1,nlayer
         DO ig=1,ngrid
          qevap(ig,l,igcm_h2o_vap)=pq(ig,l,igcm_h2o_vap)	
@@ -57,5 +57,5 @@
       ENDDO
 
-      DO l = 1, nlayermx  
+      DO l = 1, nlayer
       	DO ig = 1, ngrid
          zlvdcp=RLVTT/RCPD!/(1.0+RVTMP2*qevap(ig,l,igcm_h2o_vap))
@@ -77,4 +77,3 @@
       ENDDO
 
-      RETURN
       END
Index: trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F	(revision 1304)
+++ trunk/LMDZ.GENERIC/libf/phystd/forceWCfn.F	(revision 1308)
@@ -1,3 +1,3 @@
-      subroutine forceWCfn(ngrid,nq,pplev,pt,dq,dqs)
+      subroutine forceWCfn(ngrid,nlayer,nq,pplev,pt,dq,dqs)
 
       USE tracer_h
@@ -18,17 +18,17 @@
 !==================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 
-      INTEGER ngrid,nq
+      INTEGER ngrid,nlayer,nq
 
       real masse, Wtot, Wdiff
 
-      real pplev(ngrid,nlayermx+1)
+      real pplev(ngrid,nlayer+1)
       real pt(ngrid)
 
       real dqs(ngrid,nq) 
-      real dq(ngrid,nlayermx,nq)
+      real dq(ngrid,nlayer,nq)
 
       integer iq, ig, ilay
@@ -37,5 +37,5 @@
         do ig=1,ngrid
            Wtot = 0.0
-           do ilay=1,nlayermx
+           do ilay=1,nlayer
               masse = (pplev(ig,ilay) - pplev(ig,ilay+1))/g
               Wtot  = Wtot + masse*dq(ig,ilay,iq)
